VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "INI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "This class is used to create INI file"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'local variable(s) to hold property value(s)


Option Compare Text
Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Dest As Any, Src As Any, ByVal cb&)

Private mstrConfigName As String 'local copy
Private mstrSectionName As String 'local copy
Private mstrKeyName As String 'local copy
Private mstrKeyValue As String 'local copy
Private mstrDefault As String
'Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

'Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

'Private Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long

'Private Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

' *ONLY* API declaration, returns the default windows path.

' Characters to use in reading/writing sections.
Const T1 = "["
Const T2 = "]"

' Character to use in reading/writing keys.
Const KSEP = "="

' Protects format of multi-line strings.
Const NL_TAG = "*vbCrLf*"
Const NL_HEAD = "/"
Const NL_PROTECTED_HEAD = "/~"

' See ProtectStr function for more information.
' Set this constant to true to enable line protection.
Const PROTECT_STR = True

' These characters are invalid in an *.INI key or section.
Const INVALID_CHARS = T1 & T2 & KSEP

' An array to store the lines loaded from the INI file.
Private FileContents() As String
Private FileDateModified As Date
Private Fsys As New FileSystemObject

Private LastFileName As String
Private NTrial As Integer
' All featured proceedures follow this line.
' ------------------------------------------------------------------------

' Loads a section from an INI file
Public Function GetPrivateProfileSection(ByRef Section As String, ByRef Default As String, ByRef INIFile As String) As String
    On Error GoTo LoadERR
    Dim LoadStr As String, BeginLine As Long, EndLine As Long, i As Long, objConcat As clsConcat
    NTrial = 1
    Set objConcat = New clsConcat
LoadRetry:
    ' Is it a valid section?
    If Not ValidStr(Section) Then GoTo LoadERR
    ' Load the INI file into the FileContents database.
    OpenINIFile INIFile
    ' If the section doesn't exist, then screw it.
    If Not FindLine(BeginLine, T1 & Section & T2) Then GoTo LoadERR
    EndLine = BeginLine
    ' If there is no other section, select all data after the section
    ' until the end of the file.
    If Not FindLine(EndLine, T1) Then EndLine = GetLineCnt
    ' Gather all the data in the section.
    
    For i = BeginLine + 1 To EndLine - 2
        objConcat.AddConcat FileContents(i) & vbCrLf
    Next i
    objConcat.AddConcat FileContents(EndLine - 1)
    LoadStr = objConcat.GetString
    ' Interpret decryptable one-line string value.
    ProtectStr LoadStr, False
    ' Return the data.
    GetPrivateProfileSection = LoadStr
    Err.Clear
    GoTo ExitSub
LoadERR:
    If NTrial = 1 Then
    NTrial = 2
    OpenINIFile INIFile, True
    GoTo LoadRetry
    Else
    GoTo LoadERROR2
    End If
LoadERROR2:
    GetPrivateProfileSection = Default
ExitSub:
    Set objConcat = Nothing
End Function

' Returns a string inside an INI file.
Public Function GetPrivateProfileString(ByRef Section As String, ByRef Key As String, ByRef Default As String, ByRef INIFile As String) As String
Dim LoadStr As String, CurLine As Long, CharPos As Long
    On Error GoTo LoadERR
    NTrial = 1
LoadRetry:
    ' Is it a valid key?
    If Not ValidStr(Key) And ValidStr(Section) Then GoTo LoadERR
    ' Load the contents of the INI file into the FileContents database.
    OpenINIFile INIFile
    

    ' If the specified section doesn't exist, screw it.
    If Not FindLine(CurLine, T1 & Section & T2) Then GoTo LoadERR
    ' If the specified key doesn't exist, screw it.
    If Not FindLine(CurLine, Key & KSEP, True) Then GoTo LoadERR
    ' Look for the equal sign in the key.
    CharPos = InStr(1, FileContents(CurLine), KSEP)
    ' Get all data after the equal sign.
    LoadStr = Mid$(FileContents(CurLine), CharPos + 1)
    ' Interpret decryptable one-line string value.
    ProtectStr LoadStr, False
    ' Return the loaded string.
    GetPrivateProfileString = LoadStr
    Err.Clear
    Exit Function
LoadERR:
    If NTrial = 1 Then
    NTrial = 2
    OpenINIFile INIFile, True
    GoTo LoadRetry
    Else
    GoTo LoadERROR2
    End If
LoadERROR2:
    GetPrivateProfileString = Default
End Function

Public Sub GetPrivateProfileSections(ByRef StrArr() As String, ByRef INIFile As String)
Dim i As Integer, CurPos As Long, CharPos As Integer
    ' Load the contents of the INI file into the FileContents database.
    OpenINIFile INIFile
    Do
        ' If there are no remaining sections, then exit the proceedure.
        If Not FindLine(CurPos, T1) Then Exit Do
        i = i + 1
        ReDim Preserve StrArr(1 To i)
        CharPos = InStr(1, FileContents(CurPos), T2)
        StrArr(i) = Mid$(FileContents(CurPos), 2, CharPos - 2)
    Loop
End Sub

Public Sub GetPrivateProfileKeys(ByRef StrArr() As String, ByRef Section As String, ByRef INIFile As String)
Dim i As Integer, CurPos As Long, CharPos As Integer, WildCardKSEP As String, CurFileContents As String
    ' Is it a valid section?
    If Not ValidStr(Section) Then GoTo FindERR
    ' Load the contents of the INI file into the FileContents database.
    OpenINIFile INIFile
    ' Find the specified section.
    If Not FindLine(CurPos, T1 & Section & T2) Then Exit Sub
    ' Loop through the following lines.
    WildCardKSEP = "*" & KSEP & "*"
    Do
        CurPos = CurPos + 1
        If CurPos > GetLineCnt Then Exit Sub
        CurFileContents = FileContents(CurPos)
        ' If it is a section format, then our search is over.
        If Left$(CurFileContents, 1) = T1 Then Exit Do
        ' If it is a key format, then store it to the database.
        If CurFileContents Like WildCardKSEP Then
            i = i + 1
            CharPos = InStr(1, CurFileContents, KSEP)
            ReDim Preserve StrArr(1 To i)
            StrArr(i) = Left$(CurFileContents, CharPos - 1)
        End If
    Loop
FindERR:
End Sub


Public Sub RemovePrivateProfileSection(ByRef Section As String, ByRef INIFile As String)
Dim BeginPos As Long, EndPos As Long
    On Error GoTo DeleteERR
    ' Is it a valid section?
    If Not ValidStr(Section) Then GoTo DeleteERR
    ' Load the INI file into the FileContents array.
    OpenINIFile INIFile
    ' If the section doesn't exist, don't bother...
    If Not FindLine(BeginPos, T1 & Section & T2) Then Exit Sub
    EndPos = BeginPos
    ' Find the beginning of the next section.
    FindLine EndPos, T1, True
    ' Remove everything in the section.
    RemoveLines BeginPos, EndPos - 1
    ' Save the file to disk.
    SaveINIFile INIFile
    
DeleteERR:
End Sub

Public Sub RemovePrivateProfileString(ByRef Section As String, ByRef Key As String, ByRef INIFile As String)
Dim CurPos As Long
    On Error GoTo DeleteERR
    ' Is it a valid section? ...valid key?
    If Not ValidStr(Section) And ValidStr(Key) Then GoTo DeleteERR
    ' Load the INI file into the FileContents array.
    OpenINIFile INIFile
    ' If the specified section doesn't exist, screw it.
    If Not FindLine(CurPos, T1 & Section & T2) Then Exit Sub
    ' If the specified key doesn't exist, screw it.
    If Not FindLine(CurPos, Key & KSEP, True) Then Exit Sub
    ' Otherwise, delete the key.
    RemoveLines CurPos, CurPos
    ' Then save the INI file.
    SaveINIFile INIFile
DeleteERR:
End Sub

' Writes a string to an INI file.
Public Sub WritePrivateProfileSection(ByRef Section As String, ByRef Value As String, ByRef INIFile As String)
Dim BeginLine As Long, EndLine As Long
    On Error GoTo WriteERR
    ' Is it a valid Section?
    If Not ValidStr(Section) Then GoTo WriteERR
    ' Load the INIFile to the FileContents array.
    OpenINIFile INIFile
    ' Make Value decryptable one-line string.
    ProtectStr Value
    ' If the specified section doesn't exist, then...
    If Not FindLine(BeginLine, T1 & Section & T2) Then
        ' If we're not at the beginning of the file, then add
        ' a new line.
        If FileContents(BeginLine) > vbNullString Then AddLine ""
        ' Add the section.
        AddLine T1 & Section & T2
        ' Add the key. Even if the key is multi-lined, it still
        ' works in the FileContents array.
        AddLine Value
    Else
        EndLine = BeginLine
        ' Search for the beginning of the next section.
        FindLine EndLine, T1, True
        ' Remove all data between the current and next sections.
        RemoveLines BeginLine + 1, EndLine - 1
        ' Construct the new section.
        AddLine Value, BeginLine + 1
        AddLine "", BeginLine + 2
    End If
    ' Save the new file to disk.
    SaveINIFile INIFile
WriteERR:
End Sub

' Writes a string to the INI file.
Public Sub WritePrivateProfileString(ByRef Section As String, ByRef Key As String, ByRef Value As String, INIFile As String)
Dim CurLine As Long, LastLine As Long, NewKey As String
    'On Error GoTo WriteERR
    ' Is it a valid section? ...valid key?
    If Not ValidStr(Section) And ValidStr(Key) Then GoTo WriteERR
    ' Load the INI file into the FileContents array.
    OpenINIFile INIFile
    ' Make Value decryptable one-line string.
    ProtectStr Value
    ' The key to search for/create
    NewKey = Key & KSEP
    ' If the specified section doesn't exist, then...
    If Not FindLine(LastLine, T1 & Section & T2) Then
        ' If we're not at the beginning of the file, add a new line.
        If LastLine > 0 Then
        If FileContents(LastLine) > vbNullString Then AddLine ""
        End If
        ' Create the specified section at the end of the file.
        AddLine T1 & Section & T2
        ' Create the new key inside the new section.
        AddLine NewKey & Value
        
    Else
        ' If the specified key doesn't exist, then...
        If Not FindLine(LastLine, NewKey, True) Then
            ' Create the specified key after the section header.
            AddLine NewKey & Value, LastLine + 1
        Else
            ' Replace the value of the old key with the new value.
            FileContents(LastLine) = NewKey & Value
        End If
    End If
    ' Save the file to disk
    SaveINIFile INIFile
WriteERR:
End Sub

' ------------------------------------------------------------------------
' All featured procedures proceed this line.

' Finds and replaces a given string inside another string.
Private Function ReplaceChars(ByRef Chars As String, Optional ByRef ReplaceChr As String, Optional ByRef ReplaceWith As String) As String
Dim ChrCnt As Long, lengthChar As Long, lengthReplaceChr As Long, lengthReplaceWith As Long
lengthReplaceChr = Len(ReplaceChr)
lengthReplaceWith = Len(ReplaceWith)
    If ReplaceChr = "" Then ReplaceChr = " "
    ChrCnt = 1
    Do
        ChrCnt = InStr(ChrCnt, Chars, ReplaceChr)
        If ChrCnt = 0 Then Exit Do
        Chars = Left$(Chars, ChrCnt - 1) & ReplaceWith & Right$(Chars, Len(Chars) + 1 - lengthReplaceChr - ChrCnt)
        ChrCnt = ChrCnt + lengthReplaceWith
    Loop
    ReplaceChars = Chars
End Function

' This function is optional. If you set the PROTECT_STR constant to true,
' multi-line values stored in the INI file are combined to one line
' to avoid writing unreadable strings. For instance, if you called:

' WritePrivateProfileSection "Hello", "This is a test" & vbCrLf & "[Does it work?]", "FSoft.ini"

' You would return "This is a test" if you ran the GetPrivateProfileSection
' function to return the string. This is true in the traditional API
' commands also. If PROTECT_STR is true, this problem won't happen,
' although most INI files then are unreadable by the functions in this
' module. This is a bug-free function, and works in all situations.
Private Sub ProtectStr(StrVal As String, Optional Protect As Boolean = True, Optional Section As Boolean)
    If Not PROTECT_STR Then Exit Sub
    If Protect Then
        ReplaceChars StrVal, NL_HEAD, NL_PROTECTED_HEAD
        ReplaceChars StrVal, vbCrLf, NL_TAG
    Else
        ReplaceChars StrVal, NL_TAG, vbCrLf
        ReplaceChars StrVal, NL_PROTECTED_HEAD, NL_HEAD
    End If
End Sub

' Return the windows directory with a "\" at the end.
Private Function GetWindowsDir() As String
Dim RetStr As String, RetLen As Long
    RetStr = Space$(1024)
    RetLen = GetWindowsDirectory(RetStr, Len(RetStr))
    RetStr = Left$(RetStr, RetLen)
    ' Add a "\" at the end of the windows directory if not present.
    If Not Right$(RetStr, 1) = "\" Then RetStr = RetStr & "\"
    GetWindowsDir = RetStr
End Function

' Gets the number of lines total in the INI file.
Private Function GetLineCnt()
    On Error Resume Next
    GetLineCnt = UBound(FileContents)
End Function

' Searches through the INI file line database for a specified string.
Private Function FindLine(ByRef CurLine As Long, ByRef LineStr As String, Optional ByRef FindKey As Boolean) As Boolean
Dim LastCodeLine As Long
Dim LengthT1 As Integer
Dim LengthStr As Integer
Dim strChar1 As String

LengthT1 = Len(T1)
LengthStr = Len(LineStr)
    ' Loop through the database starting with CurLine.
strChar1 = Left$(LineStr, 1)
    For CurLine = CurLine + 1 To GetLineCnt
        ' If it isn't a blank line, keep it!
        If FileContents(CurLine) > vbNullString Then
            LastCodeLine = CurLine
        If Left$(FileContents(CurLine), LengthStr) = LineStr Then
            FindLine = True
            Exit For
        End If
        'End If
        End If

    Next CurLine
    ' Make sure the last line has code on it.
    If CurLine > LastCodeLine Then ReDim Preserve FileContents(1 To GetLineCnt + 1)
    CurLine = LastCodeLine
End Function

' Checks keys and sections for invalid characters.
Private Function ValidStr(ByRef StrVal As String) As Boolean
Dim i As Integer
    ' Assume true.
    ValidStr = True
    ' Loop through each invalid character.
    For i = 1 To Len(INVALID_CHARS)
        ' If StrVal contains that character, it is a bad string.
        If InStr(1, StrVal, Mid$(INVALID_CHARS, i, 1)) > 0 Then
            ValidStr = False
            Exit For
        End If
    Next i
End Function

' Inserts a new line into the INI file line database.
Private Sub AddLine(ByRef NewStr As String, Optional ByRef Pos As Long)
Dim i As Long
    ' Add a line at the end of the database.
    ReDim Preserve FileContents(1 To GetLineCnt + 1)
    ' If Pos = 0, we will insert the new string just added to the
    ' database.
    If Pos = 0 Then Pos = GetLineCnt
    ' Loop from the end of the database to where the new string
    ' is supposed to be coppied.
    For i = GetLineCnt To Pos + 1 Step -1
        ' Shift the previous line up one.
        FileContents(i) = FileContents(i - 1)
    Next i
    ' Add the new string to the open line.
    FileContents(Pos) = NewStr
End Sub

' Removes a stack of lines from the INI file line database.
Private Sub RemoveLines(ByRef BeginStack As Long, Optional ByRef EndStack As Long)
Dim i As Integer, j As Integer
    ' Default is to delete only one line.
    If EndStack = 0 Then EndStack = BeginStack
    ' Loop from the line after the last-to-remove lines to the
    ' end of the database.
    For i = EndStack + 1 To GetLineCnt
        ' Replace the lines to be removed with the selected line.
        FileContents(BeginStack + j) = FileContents(i)
        j = j + 1
    Next i
    ' Remove the now-unused lines.
    ReDim Preserve FileContents(1 To GetLineCnt - (EndStack - BeginStack + 1))
End Sub



' Store the FileContents array to file.
Private Sub SaveINIFile(ByRef FileName As String)
Dim i As Integer, intFile As Integer

    ' Set "C:\Windows\" as the default directory.
    ChDir GetWindowsDir
    intFile = FreeFile
    Open FileName For Output As intFile
    ' Loop through each line
    For i = 1 To GetLineCnt
        ' Add the current line to the file.
        Print #intFile, Trim(FileContents(i))
    Next i
    Close intFile
    FileDateModified = Fsys.GetFile(FileName).DateLastModified

End Sub

' Load contents from file into FileContents array.
Private Sub OpenINIFile(ByRef FileName As String, Optional ForceReadContents As Boolean = False)
Dim i As Integer, NewLine As String, intFile As Integer
    ' Delete any data already stored in FileContents array.
    On Error GoTo FileERR
    If LastFileName = FileName And FileDateModified = Fsys.GetFile(FileName).DateLastModified And Not (ForceReadContents) Then
        Exit Sub
    End If
    Erase FileContents
    ' Set "C:\Window\" as the default directory.
    ChDir GetWindowsDir
    On Error GoTo FileERR
    intFile = FreeFile
    Open FileName For Input As intFile
    ' Loop to the end of the file.
    Do While Not EOF(intFile)
        i = i + 1
        ' Retrieve the current line of data into the array.
        Line Input #intFile, NewLine
        ' Avoid blank lines.
        If NewLine = vbNullString Then
            i = i - 1
        Else
            If Left$(NewLine, 1) = T1 Then
                i = i + 1
            End If
            ReDim Preserve FileContents(1 To i)
            FileContents(i) = NewLine
        End If
    Loop
    Close intFile
    FileDateModified = Fsys.GetFile(FileName).DateLastModified
    LastFileName = FileName
FileERR:
End Sub







Public Sub DeleteSection(Optional SectionName)
    If Not (IsMissing(SectionName)) Then
        mstrSectionName = SectionName
    End If
    
    RemovePrivateProfileSection mstrSectionName, mstrConfigName
    'NOTE: vbNullString is the coding in whi
    '     ch to delete a Section, or Key
End Sub


Public Sub DeleteKey(Optional SectionName, Optional KeyName)
    If Not (IsMissing(SectionName)) Then
        mstrSectionName = CStr(SectionName)
    End If
    If Not (IsMissing(KeyName)) Then
        mstrKeyName = CStr(KeyName)
    End If
    
    RemovePrivateProfileString mstrSectionName, mstrKeyName, mstrConfigName
    'NOTE: vbNullString is the coding in whi
    '     ch to delete a Section, or Key
End Sub


Public Sub DeleteKeyValue(Optional SectionName, Optional KeyName)
    If Not (IsMissing(SectionName)) Then
        mstrSectionName = CStr(SectionName)
    End If
    If Not (IsMissing(KeyName)) Then
        mstrKeyName = CStr(KeyName)
    End If

    WritePrivateProfileString mstrSectionName, mstrKeyName, "", mstrConfigName
End Sub

Public Function Exists(Optional ConfigName) As Boolean
    Dim Fsys As FileSystemObject
    Set Fsys = New FileSystemObject
    If Not (IsMissing(ConfigName)) Then
        mstrConfigName = CStr(ConfigName)
    End If
    Exists = Fsys.FileExists(mstrConfigName)
    Set Fsys = Nothing
End Function

Public Function KeyGet(Optional SectionName, Optional KeyName, Optional Default As String = vbNullString) As String
    Dim lRet As Long
    Dim lngActualSectionLength As Long
    Dim lngActualKeyLength As Long
    Dim intFileNumber As Integer
    Dim strTemp As String
    Dim boolWithinSection As Boolean
    Dim strActualSectionName As String
    Dim strActualKeyName As String
    Dim boolFound As Boolean
    
    If Not (IsMissing(SectionName)) Then
        mstrSectionName = CStr(SectionName)
    End If
    If Not (IsMissing(KeyName)) Then
        mstrKeyName = CStr(KeyName)
    End If
    mstrDefault = Default
    mstrKeyValue = GetPrivateProfileString(mstrSectionName, mstrKeyName, mstrDefault, mstrConfigName)
    KeyGet = mstrKeyValue
End Function

Public Function SectionGet(Optional SectionName) As Variant
    Dim lRet As Long
    Dim strBuffer As String
    If Not (IsMissing(SectionName)) Then
        mstrSectionName = CStr(SectionName)
    End If
    If mstrSectionName <> vbNullString Then
        strBuffer = GetPrivateProfileSection(mstrSectionName, "", mstrConfigName)
    End If
End Function

Public Sub KeySave(Optional SectionName, Optional KeyName, Optional KeyValue)
    Dim lRet As Long
    If Not (IsMissing(SectionName)) Then
        mstrSectionName = CStr(SectionName)
    End If
    If Not (IsMissing(KeyName)) Then
        mstrKeyName = CStr(KeyName)
    End If
    If Not (IsMissing(KeyValue)) Then
        mstrKeyValue = CStr(KeyValue)
    End If
    Call WritePrivateProfileString(mstrSectionName, mstrKeyName, mstrKeyValue, mstrConfigName)
End Sub

Public Property Let KeyValue(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.KeyValue = 5
    mstrKeyValue = vData
End Property
Public Property Get KeyValue() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: X.KeyValue
    KeyValue = mstrKeyValue
End Property



Public Property Let KeyName(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.KeyName = 5
    mstrKeyName = vData
End Property
Public Property Get KeyName() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: X.KeyName
    KeyName = mstrKeyName
End Property



Public Property Let SectionName(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.SectionName = 5
    mstrSectionName = vData
End Property


Public Property Get SectionName() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: X.SectionName
    SectionName = mstrSectionName
End Property

Public Property Let ConfigName(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ConfigName = 5
    mstrConfigName = vData
End Property


Public Property Get ConfigName() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: X.ConfigName
    ConfigName = mstrConfigName
End Property




Public Sub Class_Initialize()
    mstrConfigName = App.Path & "\" & App.EXEName & ".ini"
End Sub



